<?php

// Copyright(c) 2005 Maurice Fh

/**
 * For more information read the introduction towards the end of this file.
 **/
 
// ----------------------------------------
//  Plugin information array
// ----------------------------------------

$plugin_info = array(
						'pi_name'			=> 'breadcrumb',
						'pi_version'		=> 'Beta 1',
						'pi_author'			=> 'Maurice Faeh - SHOPLER AG',
						'pi_author_url'		=> 'http://www.shopler.ch/',
						'pi_description'	=> 'Show all ancestor categories (breadcrumb trail) of a given category.',
						'pi_usage'			=> breadcrumb::usage()
					);
    
// ----------------------------------------
//  Plugin class
// ----------------------------------------

class breadcrumb {
	
	// ----------------------------------------
	//  mandatory plugin attributes
	// ----------------------------------------
	
	var $return_data = '';
	
	// ----------------------------------------
	//  plugin parameter attributes
	// ----------------------------------------
	
	var $root_node = '';		//	Stores "root_node" parameter value
	var $sort_direction = '';	//	Stores "sort_direction" parameter value

	// ----------------------------------------
	//  various plugin attributes
	// ----------------------------------------

	var $tagdata = '';			//	Stores the plugins tagdata
	var $breadcumbs = array();	//	Stores all ancester categories. Used to change sorting direction.
	
	// ----------------------------------------
	//  class constructor
	// ----------------------------------------
	
	function breadcrumb()
	{		//return subcategories
		$this->set_tagdata();
		$this->set_root_node();
		$this->set_sort_direction();
		$this->category_ancestors($this->get_root_node());
		$this->breadcrumbs_out();
		return $this->return_data;
	}
	
	// ----------------------------------------
	//  plugin 3rd segment functions
	// ----------------------------------------
	
	function test()
	{		//
	}
	
	// ----------------------------------------
	//  setter and getter functions
	//	encapsulation for class attributes
	// ----------------------------------------
	
	function set_return_data()
	{		//encapsulation of return_data attribute
	}

	function get_return_data()
	{		//encapsulation of return_data attribute
	}
	
	// ----------------------------------------
	
	function set_root_node($root_node = '')
	{		//encapsulation of root_node attribute
		global $TMPL;

		if ($root_node != '')
		{
			$this->root_node = $root_node;
		}
		else
		{
			if ($TMPL->fetch_param('root_node') != '')
			{
				$this->root_node = $TMPL->fetch_param('root_node');
			}
			else
			{
				$this->root_node = $this->url_root_node();	//	Default setting
			}
		}
	}
	/*
	validations still missing
	*/

	function get_root_node()
	{		//encapsulation of root_node attribute
		return $this->root_node;
	}
	
	// ----------------------------------------
	
	function set_tagdata()
	{		//encapsulation of tagdata attribute
		global $TMPL;

    	$this->tagdata = $TMPL->tagdata;
	}
	/*
	validations still missing
	*/

	function get_tagdata()
	{		//encapsulation of tagdata attribute
		return $this->tagdata;
	}

	// ----------------------------------------
	
	function set_sort_direction($sort_direction = '')
	{		//encapsulation of sort_direction attribute
		global $TMPL;

		if ($sort_direction != '')
		{
			$this->sort_direction = $sort_direction;
		}
		else
		{
			if ($TMPL->fetch_param('sort_direction') != '')
			{
				$this->sort_direction = strtolower($TMPL->fetch_param('sort_direction'));
			}
			else
			{
				$this->sort_direction = 'asc';	// Default setting
			}
		}
	}
	/*
	validations still missing
	*/

	function get_sort_direction()
	{		//encapsulation of sort_direction attribute
		return $this->sort_direction;
	}

	// ----------------------------------------
	//  various subfunctions
	// ----------------------------------------
	
	function url_root_node()
	{		//retrieve root_node (i.e. category ID) from URL
		global $IN;
      
	    $qstring = $IN->QSTR;
        
		// numeric category version 
		$pattern = "#^C(\d+)#";
		$subject = $qstring;
		if (preg_match($pattern, $subject, $match))
		{		
			$cat_id = $match[1];	//index 0 would output the string "C" as well
			return $cat_id;
		}
	}
	/*
	Ab EE 1.3.2 werden angeblich auch Umlaute in der URL bercksichtigt.
	
	Daher sollte die Variante wo die aktuelle Kategorie anhand ihres Namens bestimmt wird
	in Zukunft auch bercksichtigt werden.
	*/
	
	// ----------------------------------------

	function current_parent_category($current_category)
	{		//parent category of current category
		global $DB;
		
		$sql = "SELECT parent_id 
				FROM exp_categories 
				WHERE cat_id = '".$current_category."' ";
		
		$query = $DB->query($sql);
		
		if ($query->row['parent_id'] != 0)
		{
			return $query->row['parent_id'];
		}
	}
	/*
	validations still missing
	*/

	// ----------------------------------------

	function category_ancestors($current_category)
	{		//recursive function
			//reads all ancester categories of current category
		global $TMPL, $DB, $FNS;
  		
		$tagdata = $this->get_tagdata();

		$sql = "SELECT cat_id, parent_id, cat_name, cat_image, cat_description, cat_order 
				FROM exp_categories 
				WHERE cat_id = '".$DB->escape_str($this->current_parent_category($current_category))."' ";
		
		$query = $DB->query($sql);
		
		if ($query->row['cat_id'] != 0)
		{	
			// ----------------------------------------
			//   parse single variables
			// ----------------------------------------

			foreach ($TMPL->var_single as $key => $val)
			{
				//parse category_id variable
				if ($key == 'category_id')
				{
					if (isset($query->row['cat_id']))
					{
						$tagdata = $TMPL->swap_var_single($val, $query->row['cat_id'], $tagdata);
					}
				}
				//parse parent_id variable
				/*
				if ($key == 'parent_id')
				{
					if (isset($query->row['parent_id']))
					{
						$tagdata = $TMPL->swap_var_single($val, $query->row['parent_id'], $tagdata);
					}
				}*/
				//parse category_name variable
				if ($key == 'category_name')
				{
					if (isset($query->row['cat_name']))
					{
						$tagdata = $TMPL->swap_var_single($val, $query->row['cat_name'], $tagdata);
					}
				}
				//parse cat_image variable
				if ($key == 'category_image')
				{
					if (isset($query->row['cat_image']))
					{
						$tagdata = $TMPL->swap_var_single($val, $query->row['cat_image'], $tagdata);
					}
				}
				//parse cat_description variable
				if ($key == 'category_description')
				{
					if (isset($query->row['cat_description']))
					{
						$tagdata = $TMPL->swap_var_single($val, $query->row['cat_description'], $tagdata);
					}
				}
				//  parse template_path variable
				if (ereg("^template_path", $key))
				{
					$tagdata = $TMPL->swap_var_single($key, $FNS->create_url($FNS->extract_path($key).'/C'.$query->row['cat_id']), $tagdata);
				}
			}
			$this->breadcumbs[] = $tagdata;	//	store all ancestor categories
			$this->category_ancestors($query->row['cat_id']);	// recursion 
		}
	}
	
	// ----------------------------------------

	function breadcrumbs_out()
	{		//set sort order and spool "$breadcrumbs" array to "$this->return_data"
		if ($this->get_sort_direction() == 'asc')
		{
			$forward_breadcumbs = array_reverse ($this->breadcumbs);
			foreach ($forward_breadcumbs as $crumb)
			{
				$this->return_data .= $crumb;
			}
		}
		elseif ($this->get_sort_direction() == 'desc')
		{
			foreach ($this->breadcumbs as $crumb)
			{
				$this->return_data .= $crumb;
			}
		}
	}

	// ----------------------------------------
	//  Plugin Usage
	// ----------------------------------------

	function usage()
	{
		ob_start(); 
?>
Introduction:

This plugin works like any other ExpressionEngine plugin. Add the following pair of tags to your template.

{exp:breadcrumb}...{/exp:breadcrumb}



Parameters:
(1) root_node
(2) sort_direction

Variables:
(1) {category_name}
(2) {category_id}
(3) {category_description}
(4) {category_image}
(7) {template_path="template-group/template"}



Parameters:

(1) The "root_node" parameter:

Specify a category other then the category in the URL, of which you want to show ancestor categories.

- Optional
- One value only. The ID of any category that you created in EE
- Overrides the category ID in the URL

*****example*****
*
* {exp:breadcrumb root_node="365" ...}
* <li>{category_name}</li>
* {/exp:breadcrumb}
*
*****
* Show the category name of all ancestors of category 365.
*
*****


(2) The "sort_direction" parameter:

Specify a sort direction for the list of ancestors.

- Optional
- One value only. Possible values are "asc" or "desc"
- If no value is specified the plugin defaults to "asc"

*****example*****
*
* {exp:breadcrumb root_node="365" sort_direction="desc" ...}
* <li>{category_name}</li>
* {/exp:breadcrumb}
*
*****
* Show the category name of all ancestors of category 365, sorted descending.
*
*****



Variables:

(1) The {category_name} variable

- Optional
- The tag of this variable will be replaced with the name of the ancestor category

*****example*****
*
* {exp:breadcrumb root_node="365" ...}
* <li>{category_name}</li>
* {/exp:breadcrumb}
*
*****
* Show a list of category ancestors of category 365.
* Show the name of each category ancestor.
*
*****


(2) The {category_id} variable

- Optional
- The tag of this variable will be replaced with the ID of the ancestor category

*****example*****

*
* {exp:breadcrumb root_node="365" ...}
* <li>{category_id}</li>
* {/exp:breadcrumb}
*
*****
* Show a list of category ancestors of category 365.
* Show the ID of each category ancestor.
*
*****


(3) The {category_description} variable

- Optional
- The tag of this variable will be replaced with the description of the ancestor category

*****example*****
*
* {exp:breadcrumb root_node="365" ...}
* <li>{category_name} - {category_description}</li>
* {/exp:breadcrumb}
*
*****
* Show a list of category ancestors of category 365.
* Show the name of each category ancestor.
* Show the category description of each category ancestor.
*
*****


(4) The {category_image} variable

- Optional
- The tag of this variable will be replaced with the image url of the ancestor category

*****example*****
*
* {exp:breadcrumb root_node="365" ...}
* <li>{category_name} - {category_image}</li>
* {/exp:breadcrumb}
*
*****
* Show a list of category ancestors of category 365.
* Show the name of each category ancestor.
* Show the image url of each category ancestor.
*
*****


(5) The{template_path="template-group/template"} variable

- Optional
- The tag of this variable will be replaced with the complete URL to any EE template.

*****example*****
*
* {exp:breadcrumb root_node="365" ...}
* <li><a href={path="examplegroup/exampletemplate"}>{category_name}</a></li>
* {/exp:breadcrumb}
*
*****
* Show a list of category ancestors of category 365.
* Show the name of each category ancestor.
* Add a link to "exampletemplate".
*
*****



To do's:

(1) nested conditional variables
(2) add functionality to accept url categories by name
(3) add input type, konstant and other validations to all functions
(4) decide to add or not a preset output for many levels
(5) add hide_subcategories = x|y|z parameter???



Last Modification 28nd September 2005
<?php
$buffer = ob_get_contents();
	
ob_end_clean(); 

return $buffer;
}
// END


}
// END CLASS
?>